# rlbot-action-client
Allows custom Rocket League bots to accept tactical suggestions in the middle of a game.

This Python package is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: 1.1.0
- Package version: 1.0.0
- Build package: io.swagger.codegen.v3.generators.python.PythonClientCodegen

## Requirements.

Python 2.7 and 3.4+

## Installation & Usage
### pip install

If the python package is hosted on Github, you can install directly from Github

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import rlbot_action_client 
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import rlbot_action_client
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python
from __future__ import print_function
import time
import rlbot_action_client
from rlbot_action_client.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = rlbot_action_client.ActionApi(rlbot_action_client.ApiClient(configuration))
body = rlbot_action_client.ActionChoice() # ActionChoice | Action to choose

try:
    api_response = api_instance.choose_action(body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling ActionApi->choose_action: %s\n" % e)

# create an instance of the API class
api_instance = rlbot_action_client.ActionApi(rlbot_action_client.ApiClient(configuration))

try:
    api_response = api_instance.get_actions_currently_available()
    pprint(api_response)
except ApiException as e:
    print("Exception when calling ActionApi->get_actions_currently_available: %s\n" % e)
```

## Documentation for API Endpoints

All URIs are relative to */*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*ActionApi* | [**choose_action**](docs/ActionApi.md#choose_action) | **POST** /action/choose | 
*ActionApi* | [**get_actions_currently_available**](docs/ActionApi.md#get_actions_currently_available) | **GET** /action/currentlyAvailable | 

## Documentation For Models

 - [ActionChoice](docs/ActionChoice.md)
 - [ApiResponse](docs/ApiResponse.md)
 - [AvailableActions](docs/AvailableActions.md)
 - [BotAction](docs/BotAction.md)
 - [StrategicCategory](docs/StrategicCategory.md)

## Documentation For Authorization

 All endpoints do not require authorization.


## Author

rlbotofficial@gmail.com
